//==========================================================================
// MouseHookDLL.cpp
//   Windowsɒ჌x}EXtbN邽߂DLL
//==========================================================================

#include "StdAfx.h"
#include "Util.h"
#include "MouseHookDLL.h"

//---------------------------------------------------
// O[oϐ
//---------------------------------------------------

namespace
{
	#pragma data_seg("MY_HOOK_DATA")
		static HHOOK s_hook = NULL;
	#pragma data_seg()

	HINSTANCE                       s_instance = NULL;
	MouseHookDLL::MouseHookHandler* s_handler  = NULL;
}

//---------------------------------------------------
// ߂񏈗
//---------------------------------------------------

BOOL APIENTRY DllMain( HINSTANCE han, DWORD why, void* )
{
	switch( why )
	{
	case DLL_PROCESS_ATTACH: s_instance = han;               break;
	case DLL_PROCESS_DETACH: MouseHookDLL::MouseHookEnd();   break;
	}
    return TRUE;
}

LRESULT CALLBACK MouseHookDLL::LowLevelMouseProc( int code, WPARAM wp, LPARAM lp )
{
	if( code==HC_ACTION && s_handler!=NULL )
		s_handler->on_mouse_event( wp,  reinterpret_cast<MSLLHOOKSTRUCT*>(lp) );
	return ::CallNextHookEx( s_hook, code, wp, lp );
}

//---------------------------------------------------
// tbNJn/I
//---------------------------------------------------

DLL_API void MouseHookDLL::MouseHookBegin( MouseHookHandler* hh )
{
	if( s_hook==NULL )
	{
		s_handler = hh;
		s_hook    = ::SetWindowsHookEx( WH_MOUSE_LL, &LowLevelMouseProc, s_instance, 0 );
	}
}

DLL_API void MouseHookDLL::MouseHookEnd()
{
	if( s_hook!=NULL )
	{
		::UnhookWindowsHookEx( s_hook );
		s_hook    = NULL;
		s_handler = NULL;
	}
}
