//==========================================================================
// FoldableWindow.cpp
//   ܂Ȃ\EChE@\
//==========================================================================

#include "StdAfx.h"
#include "Util.h"
#include "MathUtil.h"
#include "FoldableWindow.h"
#include "Windowbacking.h"



//-----------------------------------------------------------------------
// gbvxEChE̗
//-----------------------------------------------------------------------

TopLevelWindowList::TopLevelWindowList()
{
	::EnumWindows( &EnumWindowsProc, reinterpret_cast<LPARAM>(&theList) );
}

BOOL CALLBACK TopLevelWindowList::EnumWindowsProc( HWND wnd, LPARAM lp )
{
	if( ! shouldBeIgnored(wnd) )
		reinterpret_cast<vector<HWND>*>(lp)->push_back( wnd );
	return TRUE;
}

bool TopLevelWindowList::shouldBeIgnored( HWND wnd )
{
	// ʂɏoĂȂȂ͖̂
	{
		if( ! ::IsWindowVisible(wnd) )
			return true;
		if( :: IsIconic(wnd) )
			return true;
		if( WS_CHILD & ::GetWindowLong(wnd,GWL_STYLE) )
			return true;
		RECT rc; ::GetWindowRect( wnd, &rc );
		if( rc.left==rc.right || rc.top==rc.bottom )
			return true;
	}

	// ߂ȂƎvEChENX͖
	{
		// ToDo: ݒŒǉł悤
		static const TCHAR* const ignore_list[] = {
			TEXT("Progman"),
			TEXT("Shell_TrayWnd"),
			TEXT("tooltips_class32"),
			TEXT("SysShadow"),
			TEXT("#32768"),
			WindowBacking::getWindowClass(),
		};

		TCHAR className[20]; // ToDo: MagicNumber:20߂
		::GetClassName( wnd, className, sizeof(className)/sizeof(TCHAR)-1 );

		for(int i=0; i!=lengthof(ignore_list); ++i)
			if( 0 == _tcscmp(className, ignore_list[i]) )
				return true;
	}

	// `FbNɈ܂łB
	return false;
}



//-----------------------------------------------------------------------
// `vZ
//-----------------------------------------------------------------------

int FoldedRect::isNearEdge( const dcomp& p ) const
{
	// 2:OutSide, 1:NearEdge, 0:Inside
	const int dX=20, eX=10; // dO e
	const int dY=20, eY=10; // dO e

	if( (   V[0].real()-dX<=p.real() && p.real()<=V[0].real()+eX
	     || V[2].real()-eX<=p.real() && p.real()<=V[2].real()+dX )
		 && (V[0].imag()-dY<=p.imag() && p.imag()<=V[2].imag()+dY) )
		 return 1;
	if( (   V[0].imag()-dY<=p.imag() && p.imag()<=V[0].imag()+eY
	     || V[2].imag()-eY<=p.imag() && p.imag()<=V[2].imag()+dY )
		 && (V[0].real()-dX<=p.real() && p.real()<=V[2].real()+dX) )
		 return 1;

	return rect_covers(p) ? 0 : 2;
}

void FoldedRect::foldBegin( const dcomp& p )
{
	double yCenter = (V[2].imag()+V[0].imag()) / 2;
	double yLen    = (V[2].imag()-V[0].imag());
	double xCenter = (V[2].real()+V[0].real()) / 2;
	double xLen    = (V[2].real()-V[0].real());
	double dx = - (p.imag() - yCenter) / yLen;
	double dy = + (p.real() - xCenter) / xLen;

	df     = dcomp(dx, dy);
	pf     = p + df/abs(df)*dcomp(0,1)*6.0;
	folded = true;
}

bool FoldedRect::foldContinue( const dcomp& q, const dcomp& p )
{
	if( isInside(q) || !isInside(p) )
		return false;
	if( !rect_covers(q) && !rect_covers(p) )
		return false;

	dcomp i = line_line_cross_pt(pf,df,p,q-p); // _

	double orime_len = abs(V[2]-V[0]);
	dcomp  orime_center = pf;

	dcomp crs1, crs2;
	bool ori = get_orime(crs1,crs2);
	if( ori )
		orime_len = abs(crs1-crs2), orime_center=(crs1+crs2)/2.0;

	pf = p + df/abs(df)*dcomp(0,1)*3.0;
	if( ori )
	{
		// ꂪfJقǑ傫 1,0 ɉ]B00
		double impact_pos = real( (i-orime_center)/df ) / (orime_len/2);
		double MaX = arg( (crs2-pf) / df );
		double MiN = arg( (crs1-pf) / df );

		// crs1, crs2 ݂͂łȂxɉ
		df *= polar( 1.0, max(MiN,max(impact_pos*0.05,MaX)) );
	}
	return true;
}

void FoldedRect::foldClear()
{
	folded = false;
}

bool FoldedRect::rebend( const dcomp& p1, const dcomp& p2 )
{
	if( rect_covers(p1) || rect_covers(p2)
		|| LineSegLineSegIntersectCheck(p1,p2,V[0],V[1])
		|| LineSegLineSegIntersectCheck(p1,p2,V[1],V[2])
		|| LineSegLineSegIntersectCheck(p1,p2,V[2],V[3])
		|| LineSegLineSegIntersectCheck(p1,p2,V[3],V[0]) )
	{
		if( !is_folded() )
		{
			pf = p1;
			df = p2-p1;
			folded = true;
			return true;
		}
		else
		{
			dcomp c1, c2;
			if( get_orime( c1, c2 ) )
			{
				// ToDo: C]

				// ܂ڂƐ܂ڂȂ悤Ɉړ : ToDo:t܂肾ƕςȂƂ
				if( LineSegLineSegIntersectCheck(p1,p2,c1,c2) )
				{
					if( isInside(p2) )
						pf = p2;
					if( isInside(p1) )
						pf = p1;
					return true;
				}
				// c1,c2̕Oɂ璆Ɉړ : ToDo:t܂肾ƕςȂƂ
				else if( isInside(p1) || isInside(p2) )
				{
					// pf = p1p2̂(c1,c2)牓B
					pf = (imag((p1-pf)/df) < imag((p2-pf)/df) ? p2 : p1);
					return true;
				}
			}
		}
	}
	return false;
}

bool FoldedRect::get_orime( dcomp& crs1, dcomp& crs2 ) const
{
	bool inside[] = {
		isInside(V[0]),
		isInside(V[1]),
		isInside(V[2]),
		isInside(V[3]),
		isInside(V[4]),
	};
	int j=0;
	for(int i=0; i!=4; ++i)
		if( inside[i] && !inside[i+1]   ||   !inside[i] && inside[i+1] )
		{
			dcomp pq = V[i];
			dcomp dq = V[i+1] - V[i];
			(j++==0 ? crs1 : crs2) = line_line_cross_pt( pf, df, pq, dq );
		}
	if( j < 2 )
		return false;

	if( real((crs2-pf)/df) < real((crs1-pf)/df) )
		swap(crs1,crs2);
	return true;
}

double FoldedRect::current_shape( vector<dcomp>& base, vector<dcomp>& uras ) const
{
	bool inside[] = {
		isInside(V[0]),
		isInside(V[1]),
		isInside(V[2]),
		isInside(V[3]),
		isInside(V[4]),
	};
	for(int i=0; i!=4; ++i)
	{
		if( inside[i] )
			base.push_back( V[i] );
		else
		{
			// V[i]  (pf,df) ɊւđΏۂɐ܂ʒu
			dcomp v = conj((V[i]-pf) / df) * df + pf;
			uras.push_back( v );
		}
		if( inside[i] && !inside[i+1]   ||   !inside[i] && inside[i+1] )
		{
			dcomp pq = V[i];
			dcomp dq = V[i+1] - V[i];
			dcomp crs = line_line_cross_pt( pf, df, pq, dq );
			base.push_back( crs );
			uras.push_back( crs );
		}
	}
	return area_of_polygon(base) / ((V[2].real()-V[0].real())*(V[2].imag()*V[0].imag()));
}

void FoldedRect::current_inner_ura_poly( vector<POINT>& pts ) const
{
	dcomp VV[] = {
		V[0] + dcomp( 5 ,5),
		V[1] + dcomp(-5, 5),
		V[2] + dcomp(-5,-5),
		V[3] + dcomp( 5,-5),
		V[0] + dcomp( 5 ,5),
	};
	bool inside[] = {
		isInside(VV[0]),
		isInside(VV[1]),
		isInside(VV[2]),
		isInside(VV[3]),
		isInside(VV[4]),
	};
	for(int i=0; i!=4; ++i)
	{
		if( !inside[i] )
		{
			// VV[i]  (pf,df) ɊւđΏۂɐ܂ʒu
			dcomp v = conj((VV[i]-pf) / df) * df + pf;
			POINT pnt = {(long)v.real(), (long)v.imag()};
			pts.push_back( pnt );
		}
		if( inside[i] && !inside[i+1]   ||   !inside[i] && inside[i+1] )
		{
			dcomp pq = VV[i];
			dcomp dq = VV[i+1] - VV[i];
			dcomp crs = line_line_cross_pt( pf, df, pq, dq );
			POINT pnt = {(long)crs.real(), (long)crs.imag()};
			pts.push_back( pnt );
		}
	}
}

bool FoldedRect::rect_covers( const dcomp& p ) const
{
	return (V[0].imag()<=p.imag() && p.imag()<=V[2].imag()
		&&  V[0].real()<=p.real() && p.real()<=V[2].real());
}

bool FoldedRect::covers( const dcomp& p ) const
{
	if( is_folded() )
		return rect_covers(p) && isInside(p);
	return rect_covers(p);
}



//-----------------------------------------------------------------------
// ܂ȂԂ鑋
//-----------------------------------------------------------------------

void FoldableWindow::updateShape( WindowBacking& back_r, bool b )
{
	vector<POINT> base, uras;
	double perc = shape.current_shape( base, uras );

	if( b )
	{
		if( !shape.is_folded() )
		{
			HRGN tmp = ::CreateRectRgn( 0, 0, 0, 0 );
			::CombineRgn( tmp, original_rgn, NULL, RGN_COPY );
			::SetWindowRgn( original_wnd, tmp, TRUE );
			return;
		}

		// EChĚ`ς
		HRGN tmp = ::CreateRectRgn( 0, 0, 0, 0 );
		if( base.size() >= 3 )
		{
			HRGN cut_rgn = ::CreatePolygonRgn( &base[0], base.size(), WINDING );
			::CombineRgn( tmp, cut_rgn, original_rgn, RGN_AND );
			::DeleteObject( cut_rgn );
		}
		::SetWindowRgn( original_wnd, tmp, TRUE );
	}

	// nEChĚ`ς
	back_r.renderOneWindow( shape, original_rgn );
}

bool FoldableWindow::calcShape( const dcomp& prev, const dcomp& pt )
{
	// ԑJڐFX
	if( state == ORETERU )
		return shape.foldContinue( prev, pt );

	int prevS = shape.isNearEdge( prev );
	int   ptS = shape.isNearEdge( pt );

	if( state==TAIRA && prevS==0 && ptS==1 )
	{
		state = MEKURI;
		shape.foldBegin( pt );
		return true;
	}
	else if( state==MEKURI && ptS==0 )
	{
		state = ORETERU;
		return shape.foldContinue( prev, pt );
	}
	else if( state==MEKURI && ptS==2 )
	{
		state = TAIRA;
		shape.foldClear();
		return true;
	}
	else if( state==MEKURI )
	{
		return shape.foldContinue( prev, pt );
	}
	return false;
}


